<p align="center">
  <img src="https://user-images.githubusercontent.com/20338451/124627505-9cd53a80-de4d-11eb-8d74-f81685804b05.png" width="835" height="168" /><br />
</p>

<p align="center">
Bring your Capacitor ⚡ apps to the desktop with Electron! 🖥
</p>
<p align="center">
  <a href="https://github.com/capacitor-community/electron"><img src="https://img.shields.io/badge/maintenance%20status-maintained-yellow" /></a>
   <!-- ALL-CONTRIBUTORS-BADGE:START - Do not remove or modify this section -->
<a href="#contributors"><img src="https://img.shields.io/badge/all%20contributors-11-orange?style=flat-square" /></a>
<!-- ALL-CONTRIBUTORS-BADGE:END -->
  <a href="https://www.electronjs.org/releases/stable?version=26"><img src="https://img.shields.io/badge/supported%20electron%20version-^26.2.0-blue" /></a>
</p>
<p align="center">
  <a href="https://npmjs.com/package/@capacitor-community/electron"><img src="https://img.shields.io/npm/v/@capacitor-community/electron.svg" /></a>
  <a href="https://npmjs.com/package/@capacitor-community/electron"><img alt="npm" src="https://img.shields.io/npm/dw/@capacitor-community/electron"></a>
  <a href="https://npmjs.com/package/@capacitor-community/electron"><img src="https://img.shields.io/npm/l/@capacitor-community/electron.svg?color=blue" /></a>
  <a href="https://github.com/capacitor-community/electron"><img alt="GitHub Workflow Status" src="https://img.shields.io/github/actions/workflow/status/capacitor-community/electron/ci.yml?branch=main"></a>
</p>

## ⚠ Version 4 or Above Info
- You will need version `5.4.0`+ of capacitor.
- The template and inner workings have changed a lot, a migration guide will be done but for now creating a new project to tinker with before migrating main projects is a good idea.
- Plugins from previous versions `@capacitor-community/electron` will not function in V4 or above, however all web plugins will continue to function as normal.
- V4 and later comes with no plugins out of the box. Instead V4 and later and above follow Capacitor in seperated plugins, see [Plugin Examples Directory](https://github.com/capacitor-community/electron/tree/main/plugin-examples) for examples.

## 📖 Documentation:

[You can find the docs site here.](https://capacitor-community.github.io/electron/)

## 🔐 Security

While this platform strives to be inline with current secure practices, there are things outside of this platforms control. Please take the time to read through the [security checklist](https://www.electronjs.org/docs/tutorial/security#checklist-security-recommendations) the electron team has created to keep your application as safe and secure as you possibly can.

## 🛠 Maintainers 

| Maintainer       | GitHub                                  | Social                                    | Sponsoring Company | Primary |
| ---------------- | --------------------------------------- | ----------------------------------------- | ------------------ | ------- |
| Mike Summerfeldt | [IT-MikeS](https://github.com/IT-MikeS) | [@IT_MikeS](https://twitter.com/IT_MikeS) | Volunteer          | Yes     |


## ✨ Contributors 

<!-- ALL-CONTRIBUTORS-LIST:START - Do not remove or modify this section -->
<!-- prettier-ignore-start -->
<!-- markdownlint-disable -->
<table>
  <tr>
    <td align="center"><a href="http://ionicframework.com/"><img src="https://avatars3.githubusercontent.com/u/11214?v=4?s=75" width="75px;" alt=""/><br /><sub><b>Max Lynch</b></sub></a><br /><a href="https://github.com/capacitor-community/electron/commits?author=mlynch" title="Code">💻</a> <a href="https://github.com/capacitor-community/electron/commits?author=mlynch" title="Documentation">📖</a></td>
    <td align="center"><a href="https://github.com/IT-MikeS"><img src="https://avatars0.githubusercontent.com/u/20338451?v=4?s=75" width="75px;" alt=""/><br /><sub><b>Mike Summerfeldt</b></sub></a><br /><a href="https://github.com/capacitor-community/electron/commits?author=IT-MikeS" title="Code">💻</a> <a href="https://github.com/capacitor-community/electron/commits?author=IT-MikeS" title="Documentation">📖</a></td>
    <td align="center"><a href="https://github.com/danielsogl"><img src="https://avatars2.githubusercontent.com/u/15234844?v=4?s=75" width="75px;" alt=""/><br /><sub><b>Daniel Sogl</b></sub></a><br /><a href="https://github.com/capacitor-community/electron/commits?author=danielsogl" title="Code">💻</a></td>
    <td align="center"><a href="https://github.com/vevedh"><img src="https://avatars1.githubusercontent.com/u/1430389?v=4?s=75" width="75px;" alt=""/><br /><sub><b>Hervé de CHAVIGNY</b></sub></a><br /><a href="https://github.com/capacitor-community/electron/commits?author=vevedh" title="Code">💻</a> <a href="https://github.com/capacitor-community/electron/commits?author=vevedh" title="Documentation">📖</a></td>
    <td align="center"><a href="http://twitter.com/leMaikOfficial"><img src="https://avatars2.githubusercontent.com/u/5544859?v=4?s=75" width="75px;" alt=""/><br /><sub><b>Maik Marschner</b></sub></a><br /><a href="https://github.com/capacitor-community/electron/commits?author=leMaik" title="Code">💻</a></td>
    <td align="center"><a href="https://github.com/stewones"><img src="https://avatars1.githubusercontent.com/u/719763?v=4?s=75" width="75px;" alt=""/><br /><sub><b>Stew</b></sub></a><br /><a href="https://github.com/capacitor-community/electron/commits?author=stewones" title="Code">💻</a></td>
    <td align="center"><a href="https://github.com/coreyjv"><img src="https://avatars3.githubusercontent.com/u/2730750?v=4?s=75" width="75px;" alt=""/><br /><sub><b>Corey Vaillancourt</b></sub></a><br /><a href="https://github.com/capacitor-community/electron/commits?author=coreyjv" title="Code">💻</a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/jgoux"><img src="https://avatars0.githubusercontent.com/u/1443499?v=4?s=75" width="75px;" alt=""/><br /><sub><b>Julien Goux</b></sub></a><br /><a href="https://github.com/capacitor-community/electron/commits?author=jgoux" title="Code">💻</a></td>
    <td align="center"><a href="https://github.com/MathisTLD"><img src="https://avatars.githubusercontent.com/u/42317770?v=4?s=75" width="75px;" alt=""/><br /><sub><b>MathisTLD</b></sub></a><br /><a href="https://github.com/capacitor-community/electron/commits?author=MathisTLD" title="Code">💻</a></td>
    <td align="center"><a href="https://github.com/challenger71498"><img src="https://avatars.githubusercontent.com/u/43464986?v=4?s=75" width="75px;" alt=""/><br /><sub><b>challenger71498</b></sub></a><br /><a href="https://github.com/capacitor-community/electron/commits?author=challenger71498" title="Code">💻</a></td>
    <td align="center"><a href="https://github.com/jdgjsag67251"><img src="https://avatars.githubusercontent.com/u/88368191?v=4?s=75" width="75px;" alt=""/><br /><sub><b>jdgjsag67251</b></sub></a><br /><a href="https://github.com/capacitor-community/electron/commits?author=jdgjsag67251" title="Code">💻</a></td>
  </tr>
</table>

<!-- markdownlint-restore -->
<!-- prettier-ignore-end -->

<!-- ALL-CONTRIBUTORS-LIST:END -->
